/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2008, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags. See the copyright.txt file in the
 * distribution for a full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */

package org.jboss.test.aspects.remoting;

import org.jboss.aop.advice.Interceptor;
import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.joinpoint.InvocationBase;
import org.jboss.aop.metadata.SimpleMetaData;
import org.jboss.aspects.remoting.ClusterChooserInterceptor;

/**
 * @author Brian Stansberry
 *
 */
public class MockInvocation extends InvocationBase
{

   /** The serialVersionUID */
   private static final long serialVersionUID = -8025564256411866981L;

  /**
    * Create a new MockInvocation.
    * 
    * @param interceptors
    */
   public MockInvocation(Interceptor[] interceptors)
   {
      super(interceptors);
      // TODO Auto-generated constructor stub
   }

   /**
    * Create a new MockInvocation.
    * 
    * @param interceptors
    * @param meta
    */
   public MockInvocation(Interceptor[] interceptors, SimpleMetaData meta)
   {
      super(interceptors, meta);
   }

   public Invocation copy()
   {
      return null;
   }

   public Invocation getWrapper(Interceptor[] ainterceptor)
   {
      return null;
   }

   public ClusterChooserInterceptor getClusterChooserInterceptor()
   {
      for (Interceptor i : getInterceptors())
      {
         if (i instanceof ClusterChooserInterceptor)
            return (ClusterChooserInterceptor) i;
      }
      
      return null;
   }

   public Interceptor getNextInterceptor()
   {
      boolean found = false;
      for (Interceptor i : getInterceptors())
      {
         if (found)
            return i;
         else if (i instanceof ClusterChooserInterceptor)
            found = true;
      }
      
      return null;
   }
}
