/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2008, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags. See the copyright.txt file in the
 * distribution for a full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */

package org.jboss.test.ha.client.loadbalance.aop;

import org.jboss.ha.client.loadbalance.AopLoadBalancePolicy;
import org.jboss.ha.client.loadbalance.LoadBalancePolicy;
import org.jboss.ha.client.loadbalance.aop.FirstAvailableIdenticalAllProxies;

/**
 * Tests of the FirstAvailable aop load balance policy.
 * 
 * @author Brian Stansberry
 *
 */
public class FirstAvailableIdenticalAllProxiesUnitTestCase 
extends org.jboss.test.ha.client.loadbalance.FirstAvailableIdenticalAllProxiesUnitTestCase
{
   /**
    * Create a new FirstAvailableIdenticalAllProxiesUnitTestCase.
    * 
    * @param name
    */
   public FirstAvailableIdenticalAllProxiesUnitTestCase(String name)
   {
      super(name);
   }

   @Override
   protected LoadBalancePolicy getLoadBalancePolicy()
   {
      return new FirstAvailableIdenticalAllProxies();
   }
   
   protected AopLoadBalancePolicy getAopLoadBalancePolicy()
   {
      return (AopLoadBalancePolicy) getLoadBalancePolicy();
   }
   
   public void testSelectProvidedTarget()
   {
      FirstAvailableUnitTestCase.selectProvidedTargetTest(getAopLoadBalancePolicy());
   }
   
   public void testInvalidProvidedTarget()
   {
      FirstAvailableUnitTestCase.invalidProvidedTargetTest(getAopLoadBalancePolicy());
   }
   
   public void testStickinessTrumpsProvidedTarget()
   {
      FirstAvailableUnitTestCase.stickinessTrumpsProvidedTargetTest(getAopLoadBalancePolicy());
   }
   
}
